package sumfuncts;

/**
 * @author Horst Lichter, Jochen Ludewig, 
 * Software Engineering  Grundlagen, Menschen, Prozesse, Techniken, dpunkt.verlag,
 * (c) 2023
 * params of all functions
 * a : first dummand
 * b : second summand
 */
public class AddFunctions {

  public static int add1(int a, int b) {
    return (a + b);
  }

  public static int add2(int a, int b) {
    if (a == Integer.MAX_VALUE)
      return (b / 2);
    else
      return (a + b);
  }

  public static int add3(int a, int b) {
    if (a == Integer.MAX_VALUE / 2) return (b / 2);    // S1
    else return (a + b);
  }

  public static int add4(int a, int b) {
    int s = b;
    if (a != 4444) s = a;
    return (s + b);
  }

  public static int add5(int a, int b) {
    int s = 0;
    if ((a != 555) && (b != -555)) s = a + b;
    return s;
  }

  public static int add6(int a, int b) {
    int s = a + b;
    if ((a == -b) || (b == 6666)) s = 0;
    return s;
  }

  public static int add7(int a, int b) {
    int s, a1;
    if ((b < 0) && (a >= 77)) {
      s = b + 77; a1 = a;
      do {
        s++; a1--;
      } while (a1 > 77);
      return s;
    } else
      return (a + b);
  }

  public static int add8(int a, int b) {
    int s;
    if (a == Integer.MAX_VALUE - 8) s = 1; else s = 0; // S2
    if (b == Integer.MIN_VALUE + 8) s++;               // S3
    return (a + b + s / 2);
  }

  public static int add9(int a, int b) {
    int s = Integer.MAX_VALUE / 2 + 9;
    if (a < s) return (a + b);
    else return (a % (s + 1) + b + s + 1);
  }

}
